<%
/**
 * An admin include file for editing order information.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.5.05
 */
%>

<%!
    // Constants
    private static final int FORM_SIZE = 5; 
%>

<b>Modify Orders</b><br />

<%
    //  Extract or set the ID of the order to be edited. 
    String edit_id = request.getParameter("edit_id");
    if (edit_id == null || !edit_id.matches("\\d*"))
        edit_id = "1";
%>

<form action="order_manager.jsp?action=edit" method="POST">
  Please specify an order to edit by entering an order_id: 
  <input type="text" name="edit_id" size="4" value="<%= edit_id %>" />
  <input type="submit" value="Edit" />
</form>

<% 
   // Extract POST variables relevant to form submission. 
    Enumeration columns = request.getParameterNames(); 
    while (columns.hasMoreElements())
    {
         String column = (String)columns.nextElement();
         if (!request.getParameter(column).equals("") && !column.equals("edit_id") && !column.equals("action"))
         {
             // Escape single quotes to uphold SQL integrity. 
             form.setValue(column, request.getParameter(column).replace("'", "\\'"));
         }
    }   
    
    // If there are sufficient POST variables, process the changes. 
    if (form.size() == FORM_SIZE && util.checkForms(form))
    {
        // Modify the specified order   
	query = "UPDATE orders SET ";
	for (int i = 0; i < form.size(); i++)
        {
            query += form.getKey(i) + " = '" + form.getValue(i) + "'";
            if (i < form.size() - 1)
                query += ", ";
            else
                query += " ";
        }
	query += "WHERE order_id = '" + edit_id + "';";
	if (db.update(query) > 0)
	    out.println("Update successful. <br /><br />");
	else
	    out.println("Update failed. <br /><br />");
    }
    else
    {
        // Print error messages if necessary. 
        if (form.size() != 0 && form.size() != FORM_SIZE)
            out.println("Update failed. Please fill out every field.<br />");
        else if (!util.checkForms(form))
            out.println("Update failed. Some fields contained incorrect data.<br />");
    }
    
    // Extract information about the order that is currently being edited.
   query = "SELECT * FROM orders WHERE order_id = '" + edit_id + "';";
   result = db.query(query);
   
    if (result.next())
    {
        ResultSetMetaData rsmd = result.getMetaData();
        for (int i = 1; i <= rsmd.getColumnCount(); i++)
        {
            String column = rsmd.getColumnName(i);
            if (!column.equals("edit_id"))
                form.setValue(column, result.getString(i));
        }
        out.println("<b>Currently editing order_id " + edit_id + ".</b>");
    }        
    else 
        out.println("Sorry, but the specified order does not exist. Please try again.");
%>

<form action="order_manager.jsp?action=edit" method="post">
  <table>
    <tr>
      <td>
        Product ID:
      </td>
      <td>
        <input type="text" name="product_id" value="<%= form.getValue("product_id") %>" />
      </td>
    </tr>
    <tr>
      <td>
        User ID:
      </td>
      <td>
        <input type="text" name="user_id" value="<%= form.getValue("user_id") %>" />
      </td>
    </tr>
    <tr>
      <td>
        Due Date:
      </td>
      <td>
        <input type="text" name="due_date" value="<%= form.getValue("due_date") %>" />
      </td>
    </tr>
    <tr>
      <td>
        Fee:
      </td>
      <td>
        <input type="text" name="fee" value="<%= form.getValue("fee") %>" />
      </td>
    </tr>
    <tr>
      <td>
        Returned:
      </td>
      <td>
        <select name="returned">
	  <option value="0" <% if (form.getValue("returned").equals("0")) { out.println("selected=\"true\""); }%>>False</option>
	  <option value="1" <% if (form.getValue("returned").equals("1")) { out.println("selected=\"true\""); }%>>True</option
	</select>
      </td>
    </tr>
  </table>
  <br />
  <input type="hidden" name="edit_id" value="<%= edit_id %>" />
  <input type="submit" value="Submit Changes" />
</form>


