<%
/**
 * A file for managing orders.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>


<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.Date"              %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.Enumeration"      %>
<%@ page import="java.text.NumberFormat"     %>

<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<%! 
    // Constants
    private static final int DEFAULT_INDEX  = 1;
    private static final int DEFAULT_NUMBER = 20;
%>

<%
    // Ensure user is an admin (no falsified URLs)
    if (!user.getValue("user_type").equals("admin"))
        response.sendRedirect(response.encodeRedirectURL("/movies/index.jsp"));
%>

<div class="page">
  Order Manager:
  <a href="order_manager.jsp?action=all">All Orders</a> |
  <a href="order_manager.jsp?action=current">Current Orders</a> |
  <a href="order_manager.jsp?action=overdue">Overdue Orders</a> |
  <a href="order_manager.jsp?action=edit">Modify Orders</a>
  <br />
  <br />

<%
    String query = "SELECT o.order_id, p.product_id, u.user_id, " +
                   "o.date AS 'Transaction Date', o.due_date AS 'Due Date', " +
		   "o.returned AS Returned, p.title AS Title, o.fee AS Price " +
                   "FROM users u, products p, orders o " +
		   "WHERE p.product_id = o.product_id AND o.user_id = u.user_id ";

    ResultSet result = null;

    // Make a number formatter for outputting floats
    NumberFormat nf = NumberFormat.getInstance();
    nf.setMaximumFractionDigits(2);
    nf.setMinimumFractionDigits(2);

    // Extract or set the page action. 
    String action = request.getParameter("action");
    if (action == null)
        action = "all";

    // Load the appropriate content based on the page action. 	
    if (action.equals("all"))
    {
       out.println("<b>All Orders</b><br />");
       query += "ORDER BY o.date DESC;";
    }
    else if (action.equals("current"))
    {
       out.println("<b>Current Orders</b><br />");
       query += "AND o.returned = '0' ORDER BY o.date DESC;";
    }
    else if (action.equals("overdue"))
    {
       out.println("<b>Overdue Orders</b><br />");
       Date date = new Date(System.currentTimeMillis());
       query += "AND o.returned = '0' AND o.due_date < '" + date + "' " +
	        "ORDER BY o.due_date DESC;";
    }
    else // if (action.equals("edit"))
    {
        %><%@ include file="order_edit.jsp" %><%
    }
    
    if (action.equals("all") || action.equals("current") || action.equals("overdue"))
    {
        // Display the listing form
	int number = DEFAULT_NUMBER;
	int index  = DEFAULT_INDEX;
        if (request.getParameter("number") != null && request.getParameter("number").matches("\\d*"))
	    number = Integer.parseInt(request.getParameter("number"));
        if (request.getParameter("index") != null && request.getParameter("index").matches("\\d*"))
	    index = Integer.parseInt(request.getParameter("index")); 
%>
    <form action="order_manager.jsp?action=<%= action %>" method="POST">
      Return 
      <input type="text" name="number" size="4" value="<%= number %>" /> orders, starting with result #
      <input type="text" name="index" size="4" value="<%= index %>" />  
      <input type="submit" value="List" />
      <br />
    </form>
<%
        // Display the result set
	result = db.query(query);
	ResultSetMetaData rsmd = result.getMetaData();
	
	out.println("<table border=\"1\" width=\"95%\">");
        
        // Label the columns
        out.println("<tr>");
        out.println("<th></th>");
        for (int i = 1; i <= rsmd.getColumnCount(); i++)
    	    out.println("<th><font size=\"1\">" + rsmd.getColumnLabel(i) + "</font></th>");
        out.println("</tr>");

        // Drop the users table to output
	int count = index;
        while (result.absolute(count) && count < index + number)
        {
            out.println("<tr>");
            if (result.getString("returned").equals("0"))
            {
                out.println("<td><a href=\"/movies/admin/store_manager.jsp?action=check_in&order_id=" + 
                    result.getString("order_id") + "&product_id=" + result.getString("product_id") 
                        + "&user_id=" + result.getString("user_id") + "&return=" + request.getRequestURL() + "\">Check-In</a></td>");
            }
            else
                out.println("<td>&nbsp;</td>");

            for (int i = 1; i <= rsmd.getColumnCount(); i++)
                out.println("<td><font size=\"1\">" + result.getObject(i) + "</font></td>");
            out.println("</tr>");  
	    count++;
        }
        out.println("</table>");
    }
%>

</div>

<%@ include file="/movies/include/footer.tpl" %>
