<%
/**
 * An admin include file that facilitates addition of new
 * products to the database.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%
    // Check for MIME form submissions
    if (MultipartFormDataRequest.isMultipartFormData(request))
    {
        // Attempt to process the form

        MultipartFormDataRequest mr = new MultipartFormDataRequest(request);
        edit_id = mr.getParameter("edit_id");

        // Extract form-related POST values
        Enumeration columns = mr.getParameterNames(); 
        while (columns.hasMoreElements())
        {
             String column = (String)columns.nextElement();
             if (!mr.getParameter(column).equals("") && !column.equals("submit") && !column.equals("icon") 
                 && !column.equals("edit_id") && !column.equals("action"))
             {
	         // Escape single quotes to preserve SQL integrity
                 form.setValue(column, mr.getParameter(column).replace("'", "\\'"));
             }
        } 

        // Update the database if the form was filled out correctly. 
        if (form.size() == ADD_FORM_SIZE && util.checkForms(form))
        { 
            String query1 = "INSERT INTO products (";
            String query2 = "VALUES (";

            for (int i = 0; i < form.size(); i++)
            {
                query1 += form.getKey(i) + ", ";
                query2 += "'" + form.getValue(i) + "', ";
            }
            query1 += "rating, ratings, rentals, in_stock, ";
            query2 += "'0', '0', '0', " + form.getValue("quantity") + ", ";

            // Handle image file uploads using the Javazoom bean.
            Hashtable files = mr.getFiles();
            if (((UploadFile)mr.getFiles().get("icon")).getFileName() != null)
            {
	        // Examine the file's extension
                String file_name = ((UploadFile)mr.getFiles().get("icon")).getFileName();
 	        int index = file_name.length() - 1;
		while (file_name.charAt(index) != '.')
		    index--;
		    
		String extension = file_name.substring(index, file_name.length());
		
		if (extension.equalsIgnoreCase(".jpg") || extension.equalsIgnoreCase(".gif"))
		{
		    // Safe file extension, process the upload. 
                    UploadFile ufile = (UploadFile)files.get("icon");
                    long name = System.currentTimeMillis();
                    ufile.setFileName(name + extension);
                    UploadBean ub = new UploadBean();
                    ub.setStoremodel(UploadBean.FOLDERSTORE);
                    ub.setFolderstore("C:\\Program Files\\Apache Software Foundation\\Tomcat 5.5\\webapps\\ROOT\\movies\\images\\icons");
                    ub.store(mr, "icon");
                    query1 += "icon) ";
                    query2 += "'" + IMG_DIRECTORY + name + extension + "');";
		}
            }
            else
            {
                query1 += "icon) ";
                query2 += "'" + IMG_DIRECTORY + "default.jpg');"; 
            }

            if (db.update(query1 + query2) > 0)
                out.println("Product added successfully. <br />");
            else
                out.println("Product addition failed. (Internal Error) <br />");
        }
        else
            out.println("Please complete all fields. However, you have the option of omitting an image icon. <br />");           
    }
    else
        out.println("Here you can add new movies and games to the product database. Additions made on this page will be immediately visible to users of the site. If you make a mistake, you can edit this information using the \"Modify Products\" page.");
 %>