<%
/**
 * A file that facilitates product management. This page provides 
 * access to the product addition, modification, and listing pages. 
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%@ page import="java.sql.ResultSet"                   %>
<%@ page import="java.sql.ResultSetMetaData"           %>
<%@ page import="java.util.Enumeration"                %>
<%@ page import="java.io.File"                         %>               
<%@ page import="javazoom.upload.*"                    %>
<%@ page import="java.util.Hashtable"                  %>

<jsp:useBean id="util"   class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"     class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user"   class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form"   class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%!
    // Constants
    private static final int    ADD_FORM_SIZE    = 8;  
    private static final int    MODIFY_FORM_SIZE = 10;
    private static final String DEFAULT_INDEX    = "1";
    private static final String DEFAULT_NUMBER   = "20";
    private static final String IMG_DIRECTORY    = "/movies/images/icons/";
%>

<%
    // Ensure user is an admin (no falsified URLs)
    if (!user.getValue("user_type").equals("admin"))
        response.sendRedirect(response.encodeRedirectURL("/movies/index.jsp"));
%>

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">

  Product Manager: 
  <a href="product_manager.jsp?action=view">List Products</a> | 
  <a href="product_manager.jsp?action=add">Add Products</a> | 
  <a href="product_manager.jsp?action=modify">Modify Products</a> |
  <a href="product_manager.jsp?action=meta">Meta Options</a>
  <hr />

<%
    String query = "";
    ResultSet result = null;
    
    // Extract the page action and react accordingly
    String action = request.getParameter("action");
    String edit_id = request.getParameter("edit_id");

    if (action == null)
        action = "view";
        
    if (edit_id == null || !edit_id.matches("\\d*"))
        edit_id = "1";    

    if (action.equals("view"))
    {
        %><%@ include file="product_view.jsp" %><%   
    }
    else if (action.equals("modify"))
    {
        %><%@ include file="product_edit.jsp" %><%        
    }
    else if (action.equals("add"))
    {
        %><%@ include file="product_add.jsp"  %><%        
    }
    else // if action.equals("meta")
    {
        %><%@ include file="product_meta.jsp" %><%
    }

    // If adding or modifying a product, display the form. 
    if (action.equals("add") || action.equals("modify"))
    {
        // Display the form
        %>
        <form action="product_manager.jsp?action=<%= action %>" enctype="multipart/form-data" method="post">
          <table>
            <tr>
              <td>
                Title:
              </td>
              <td>
                <input name="title" type="text" value="<%= form.getValue("title") %>" />
              </td>
            </tr>
	    <tr>
              <td>
                Fee Type:
              </td>
              <td>
	        <select name="fee_type">
<%
       // Extract all fee types from the fee table
       query  = "SELECT * FROM fees";
       result = db.query(query);

       while (result.next())
       {
           String fee_name = result.getString("fee_name");
%>
                  <option value="<%= fee_name %>" <% if (form.getValue("fee_type").equals(fee_name)) { out.println("selected=\"true\"");} %>><%= fee_name %></option>
<%
       }
%>
                </select>
              </td>
            </tr>
            <tr>
              <td>
                Media Type:
              </td>
              <td> 
                <select name="type">
<%
       // Extract all media types from the media types table
       query  = "SELECT * FROM media_types";
       result = db.query(query);

       while (result.next())
       {
           String type_name = result.getString("type_name");
%>
                  <option value="<%= type_name %>" <% if (form.getValue("type").equals(type_name)) { out.println("selected=\"true\"");} %>><%= type_name %></option>
<%
       }
%>
                </select>
              </td>
            </tr>
	    <tr>
              <td>
                Rated:
              </td>
              <td>
	        <select name="rated">
<%
       // Extract all rating types from the ratings table
       query  = "SELECT * FROM ratings";
       result = db.query(query);

       while (result.next())
       {
           String rating_name = result.getString("rating_name");
%>
                  <option value="<%= rating_name %>" <% if (form.getValue("rated").equals(rating_name)) { out.println("selected=\"true\"");} %>><%= rating_name %></option>
<%
       }
%>
                </select>
              </td>
            </tr>
            <tr>
              <td>
                Release Date:
              </td>
              <td>
                <input name="date"  type="text" value="<%= form.getValue("date")  %>" /> (XXXX-XX-XX)
              </td>
            </tr>
            <tr>
              <td>
                Genres:
              </td>
              <td> 
                <input name="genre" type="text" value="<%= form.getValue("genre") %>" /> 
              </td>
            </tr>
            <tr>
              <td>
                Quantity:
              </td>
              <td> 
                <input name="quantity" type="text" value="<%= form.getValue("quantity") %>" /> 
              </td>
            </tr>
            <%
        if (action.equals("modify"))
        {
            %>
            <tr>
              <td>
                In-Stock:
              </td>
              <td> 
                <input name="in_stock" type="text" value="<%= form.getValue("in_stock") %>" /> 
              </td>
            </tr>
            <tr>
              <td>
                Rentals:
              </td>
              <td> 
                <input name="rentals" type="text" value="<%= form.getValue("rentals") %>" /> 
              </td>
            </tr>
            <tr>
              <td>
                Reset Rating?
              </td>
              <td> 
                <input name="rating" type="checkbox" /> 
              </td>
            </tr>
            <tr>
              <td>
                Delete Product?
              </td>
              <td> 
                <input name="delete" type="checkbox" /> 
              </td>
            </tr>
            <%
        }
            %>
            <tr>
              <td>
                Description:
              </td>
              <td> 
                <textarea name="description" rows="5" cols="50"><%= form.getValue("description") %></textarea> 
              </td>
            </tr>
            <tr>
              <td>
                Icon Image:<br /><% if (!form.getValue("icon").equals("")) { out.println("<img src=\"" + form.getValue("icon") + "\" />"); } %>
              </td>
              <td>                 
                <input name="icon" type="file" /> 
              </td>
            </tr>
            <tr>
              <td> 
                <input type="submit" value="Submit Changes" />
                <input name="edit_id" type="hidden" value="<%= edit_id %>" /> 
              </td>
            </tr>
          </table>
        </form>
            <%
    }  
%>
</div>

<%@ include file="/movies/include/footer.tpl"     %>