<%
/**
 * An admin include file that provides sales summaries by way
 * of database analysis. This file was largely generated as SQL practice.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.5.05
 */
%>

<%
    String    query  = "";
    ResultSet result = null;
    
    // Values to be extracted and calculated from database
    float  gross_sales   = 0;
    float  current_sales = 0;
    float  todays_sales  = 0;
    
    // Calculate gross sales
    query  = "SELECT SUM(fee) AS gross_sales FROM orders;";
    result = db.query(query);
    if (result.next())
        gross_sales = result.getFloat("gross_sales"); 
	
    // Calculate current sales
    query = "SELECT SUM(fee) AS current_sales " +
            "FROM orders WHERE returned = '0';";
    result = db.query(query);
    if (result.next())
        current_sales = result.getFloat("current_sales"); 

    // Calculate todays sales
    query = "SELECT sum(fee) AS todays_sales FROM orders " +
            "WHERE date = '" + (new Date(System.currentTimeMillis())) + "';";

    result = db.query(query);
    if (result.next())
        todays_sales = result.getFloat("todays_sales"); 
%>

<table width="80%">
  <tr>
    <td colspan="2"><b>Sales Summary</b> (Excluding Damage and Late Fees)</td>
  </tr>
  <tr>
    <td>Gross Sales</td>
    <td><%= "$" + nf.format(gross_sales) %></td>
  </tr>
  <tr>
    <td>Current Sales</td>
    <td><%= "$" + nf.format(current_sales) %></td>
  </tr>
    <tr>
    <td>Today's Sales</td>
    <td><%= "$" + nf.format(todays_sales) %></td>
  </tr>
</table>
<br />
<b>Alltime Bestsellers</b>
<br />
<table width="80%">
<%
    // Calculate items that have generated the most profit
    query = "SELECT SUM(fee) as sum, o.product_id, title FROM orders o, products p " + 
            "WHERE p.product_id = o.product_id GROUP BY o.product_id ORDER BY sum DESC LIMIT 5;";
    result = db.query(query);
    while (result.next())
    {
%>  
  <tr>
    <td><%= "$" + nf.format(result.getFloat("sum")) %></td>
    <td><%= result.getString("title") %></td>
  </tr>
<%
    }
%>
</table>
<br />
<b>Hot Items</b>
<br />
<table width="80%">
<%
    // Calculate recent items that have generated the most profit
    query = "SELECT SUM(fee) as sum, o.product_id, title FROM orders o, products p " + 
            "WHERE p.product_id = o.product_id AND o.date > '" + (new Date(System.currentTimeMillis() - 7 * 24 * 60 * 60 * 1000)) + "' GROUP BY o.product_id ORDER BY sum DESC LIMIT 5;";
    result = db.query(query);
    while (result.next())
    {
%>  
  <tr>
    <td><%= "$" + nf.format(result.getFloat("sum")) %></td>
    <td><%= result.getString("title") %></td>
  </tr>
<%
    }
%>
</table>


