<%        
/**
 * An admin include file that facilitates user modification.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%
    // Handle possible form submissions. 
    if (request.getParameter("form_set") != null)
    {
        // An update form was submitted. Attempt to process.
            
        // Load in all POST variables related to form submission. 
        Enumeration columns = request.getParameterNames(); 
        while (columns.hasMoreElements())
        {
            String column = (String)columns.nextElement();
            if (!request.getParameter(column).equals("") && !column.equals("submit") 
                && !column.equals("form_set") && !column.equals("edit_id") && !column.equals("action")
                    && (action.equals("add") || !column.equals("password")))
            {
	       // Escape single quotes to preserve SQL integrity
               form.setValue(column, request.getParameter(column).replace("'", "\\'"));
	    }
        } 
         
        // Handle deletion requests
        if (form.getValue("delete").equals("on"))
        {
            // Delete the user's account
            String query = "DELETE FROM users WHERE user_id = '" + edit_id + "';";
            int result = db.update(query);
            if (result> 0)
            {
                out.println("User deleted successfullly. <br />");
                form.empty();
            }   
            else
                out.println("Deletion failed. <br />"); 
        }
        else if (form.size() == MODIFY_FORM_SIZE && util.checkForms(form))
        {
            // Form filled out completely and correctly. Process the changes. 

            String query = "UPDATE users SET ";
   
            for (int i = 0; i < form.size(); i++)
            {
                query += form.getKey(i) + " = '" + form.getValue(i) + "'";
                if (i < form.size() - 1)
                    query += ", ";
            }

            String password  = request.getParameter("password");
            String password2 = "";
            if (password != null && password.equals("on"))
            {
                // Randomize a new password. 
                password = "";
                for (int i = 0; i < 4; i++)
                    password += (char)((int)(Math.random() * 10) + 48);

                password2 = password;

                // Encrypt the password
                MessageDigest md = MessageDigest.getInstance("MD5");
                md.update(password.getBytes("UTF8"));
                password = (new BASE64Encoder().encode(md.digest())).replace("'", "\\'"); 

                query += ", password = '" + password + "'";
            }

            query += "WHERE user_id = '" + request.getParameter("edit_id") + "';";
                 
            int result = db.update(query);
              
            if (result > 0)
            {
                out.println("User's data updated successfully. <br />");
                if ((request.getParameter("password") != null) && request.getParameter("password").equals("on"))
                    out.println("Password reset: " + password2 + "<br />");
            }
            else
                out.println("Update failed. (Internal Error)<br />");
        }
        else
        {
            if (form.size() > 0 && form.size() != MODIFY_FORM_SIZE)
                out.println("Product modification failed. Please ensure every form element has a value. However, you have the option of not specifying a new image icon.<br />");
            else 
                out.println("Product modification failed. Some fields contained incorrect values.<br />");
        } 
    }

    // Allow user to specify an account to edit.       
%>

    <form action="user_manager.jsp?action=modify" method="POST">
      Please specify an account to modify by entering a user_id: 
      <input type="text" name="edit_id" size="4" value="<%= edit_id %>" />
      <input type="submit" value="Edit" />
    </form>

<%        
    if (edit_id == null || !edit_id.matches("\\d*"))
        edit_id = "1";

    // Gather information regarding user currently being edited. 
    String query = "SELECT * FROM users WHERE user_id = '" + edit_id + "';";
    ResultSet result = db.query(query);

    if (result.next())
    {
        ResultSetMetaData rsmd = result.getMetaData();
        for (int i = 1; i <= rsmd.getColumnCount(); i++)
        {
            String column = rsmd.getColumnName(i);
            if (!column.equals("password")  && !column.equals("edit_id"))
                form.setValue(column, result.getString(i));
        }
        out.println("<b>Currently editing user_id " + edit_id + ".</b><br /><br />");
    }        
    else 
        out.println("Sorry, but the specified user does not exist. Please try again.<br />");
%> 