<%
/**
 * A file for managing user accounts, including user addition, 
 * modification, and listing. 
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.3.05
 */
%>

<%@ page import="java.sql.ResultSet"          %>
<%@ page import="java.sql.ResultSetMetaData"  %>
<%@ page import="java.util.Enumeration"       %>
<%@ page import="java.security.MessageDigest" %>
<%@ page import="sun.misc.BASE64Encoder"      %>

<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%!
    // Constants
    private static final String DEFAULT_INDEX  = "1";
    private static final String DEFAULT_NUMBER = "20";
    private static final int MODIFY_FORM_SIZE  = 10;
    private static final int ADD_FORM_SIZE     = 11; 
%>

<%
    // Ensure user is an admin (no falsified URLs)
    if (!user.getValue("user_type").equals("admin"))
        response.sendRedirect(response.encodeRedirectURL("/movies/index.jsp"));
%>

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">

  User Manager: 
  <a href="user_manager.jsp?action=view">List Accounts</a> | 
  <a href="user_manager.jsp?action=add">Add Accounts</a> | 
  <a href="user_manager.jsp?action=modify">Modify Accounts</a>
  <hr />

<%
    // Extract or set page action and edit_id. 
    String action  = request.getParameter("action");
    String edit_id = request.getParameter("edit_id");

    if (action == null)
        action = "view";

    if (edit_id == null)
        edit_id = "1";

    // Include the appropriate file based on the current page action. 
    if (action.equals("view"))
    {
        %><%@ include file="/movies/admin/user_view.jsp" %><%
    }
    else if (action.equals("modify"))
    { 
        %><%@ include file="/movies/admin/user_edit.jsp" %><%         
    }
    else // if action.equals("add")
    {
        %><%@ include file="/movies/admin/user_add.jsp" %><%
    }

    // If adding or modifying a user, include the necessary form. 
    if (action.equals("add") || action.equals("modify"))
    {
%>

            <form action="user_manager.jsp?action=<%= action %>" method="POST">
              <input name="form_set" type="hidden" value="true" />
              <table>
                <tr>
                  <td>User Type:</td>
                  <td>
                    <select name="user_type">
                      <option value="enduser">End User</option>
                      <option value="admin" <% if (form.getValue("user_type").equals("admin")) out.println(" selected=\"true\" "); %>>Administrator</option>
                    </select>
                  </td>
                </tr>
        
<% 
        if (action.equals("modify")) 
        { 
%>
                <tr>
                  <td>Delete User?</td>
                  <td><input name="delete" type="checkbox" /></td>
                <tr>
                  <td>Reset Password?</td>
                  <td><input name="password" type="checkbox" /></td>
                </tr>

                <tr>
                  <td><br /><br /></td>
                  <td><br /><br /></td>
                </tr>
<%
        }
%>
                <tr>
                  <td>Login:</td>
                  <td><input name="login" type="text" value="<%= form.getValue("login") %>"></td>
               </tr>
<% 
        if (action.equals("add")) 
        {
%>

                <tr>
                  <td>Password:</td>
                  <td><input name="password" type="password"></td>
                </tr>
<%  
        }
%>
                <tr>
                  <td>Email</td>
                  <td><input name="email" type="text" value="<%= form.getValue("email") %>"></td>
                </tr>
                <tr>
                  <td>First Name:</td>
                  <td><input name="first" type="text" value="<%= form.getValue("first") %>"></td>
                </tr>
                <tr>
                  <td>Last Name:</td>
                 <td><input name="last" type="text" value="<%= form.getValue("last") %>"></td>
                </tr>
                <tr>
                  <td>Street Address:</td>
                  <td><input name="address" type="text" value="<%= form.getValue("address") %>"></td>
                </tr>
                <tr>
                  <td>City</td>
                  <td><input name="city" type="text" value="<%= form.getValue("city") %>"></td>
                </tr>
                <tr>
                  <td>State</td>
                  <td><input name="state" type="text" value="<%= form.getValue("state") %>"></td>
                </tr>
                <tr>
                  <td>Zip:</td>
                  <td><input name="zip" type="text" value="<%= form.getValue("zip") %>"></td>
                </tr>
                <tr>
                  <td>Phone:</td>
                  <td><input name="phone" type="text" value="<%= form.getValue("phone") %>">###-###-####</td>
                </tr>
              </table>
              <input type="hidden" name="edit_id" value="<%= edit_id %>" />
              <input type="submit" name="submit"  value="Submit Changes" />
            </form> 
<%  
    }  
%>

</div>
<%@ include file="/movies/include/footer.tpl"     %>