package mcintyr.edu.montana.cs.esus;

import java.sql.Connection;
import java.sql.Statement;
import java.sql.DriverManager;
import java.sql.ResultSet; 

/**
 * A bean that provides a connection and access to a MySQL
 * database as well as exception handling. 
 *
 * @Author  - Kyle McIntyre
 * @Version - 5.26.05
 */

public class DatabaseConnection
{
    private Statement  statement; 
    private Connection database;  

    /** 
     * Default constructor that instantiates the database 
     * connection by providing a JDBC driver.
     */

    public DatabaseConnection()
    {
        try
        {
            Class.forName("org.gjt.mm.mysql.Driver");
            database  = DriverManager.getConnection("jdbc:mysql://localhost/project","root","Illoryia");
            statement = database.createStatement();
        }
        catch (Exception e)
        {
            System.out.println("ERROR: " + e + e.getMessage());
        }
    }
 
    /**
     * Used for making SQL updates such as UPDATE, INSERT,
     * and DELETE. 
     *
     * @return - The number of rows affected in the database.
     */

    public int update(String query)
    {
        try 
        {
            return statement.executeUpdate(query);
        }
        catch (Exception e) 
        {
            System.out.println(ERROR: " + e + e.getMessage());
            return 0;
        }
    }

    /**
     * Used for querying the database (SELECT statements). 
     *
     * @return - A ResultSet object containing the query's results. 
     */ 
    
    public ResultSet query(String query)
    {
        try 
        {
            return statement.executeQuery(query);
        }
        catch (Exception e) 
        {
            System.out.println(ERROR: " + e + e.getMessage());
            return null;
        } 
    }
}   