package mcintyr.edu.montana.cs.esus;

import java.util.ArrayList;

/**
 * A bean for storing and returning user information 
 * across sessions. Utilizes an associative array. 
 * This bean is meant to be used with session scope
 * so that the User values can follow a particular
 * user during his or her session.  
 *
 * @Author  - Kyle McIntyre
 * @Version - 5.26.05
 */

public class User extends AssociativeArray
{
    public User()
    { 
        super();
   
        /**
         * Users are guests by default. 
         * These values are changed when the user logs in. 
         */

        this.setValue("user_id", "0");
        this.setValue("user_type", "guest");
        this.setValue("first", "Guest");
    }
}