<%
/**
 * A file for displaying details about a particular product.
 *
 * @Author  - Kyle McIntyre
 * @Version - 5.29.05
 */
%>

<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.StringTokenizer"  %>

<jsp:useBean id="util"   class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"     class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user"   class="mcintyr.edu.montana.cs.esus.User"               scope="session" />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<%!
    // Page variables
    private String cart = "";

    /**
     * Returns the Request parameter specified by the name parameter,
     * but rather than returning null if the parameter does not exist,
     * this function returns the empty string.
     *
     * @Param request - The request object of the current page.
     * @Param name    - The name of the parameter to be extracted.
     * @Return - The corresponding parameter value as a string object.
     */

    private String getParameter(HttpServletRequest request, String name)
    {
        String value = request.getParameter(name);
        if (value == null)
            return "";
        else
            return value;
    }

    private String getCartMarkup(String product_id, int in_stock)
    {
       
        if (in_stock <= 0)
        {
            // Product out of stock, prevent addition to shopping cart.
            return "<font color=\"red\">Sorry, this item is currently out of stock.</font>";
        }
        else
        {
            StringTokenizer toke = new StringTokenizer(cart, ",");
            boolean full = false;
            while (toke.hasMoreTokens())
            {
                if (product_id.equals(toke.nextToken()))
                    full = true;
            }
         
            if (full)
                return "<b>In Your Cart</b>";
            else
                return "<a href=\"/movies/enduser/add.jsp?product_id=" + product_id + "\">Add to Cart</a>"; 
        }   
    }
%>

<div class="page">

<%
    // Extract the product ID
    String product_id = getParameter(request, "product_id");
    if (product_id.equals(""))
        product_id = "1";

    // Extract cart information
    cart = user.getValue("cart");

    // Get the product's information from the database.
    String query = "SELECT * FROM products WHERE product_id = '" + product_id + "';";
    ResultSet result = db.query(query);
    ResultSetMetaData rsmd = result.getMetaData();
    result.next();

    // If the user rated the title, process the rating
    String rating = getParameter(request, "rating");
    int score = 0;
    if (!rating.equals(""))
    { 
        int new_rating = result.getInt("rating") + Integer.parseInt(rating);
        int new_count  = result.getInt("ratings") + 1;

        query = "UPDATE products SET ratings = '" + new_count + "', rating = '" + new_rating + "' " + 
                "WHERE product_id = '" + product_id + "';";

        db = new mcintyr.edu.montana.cs.esus.DatabaseConnection();

        if (db.update(query) > 0)
            out.println("Title rated successfully. Thank you! <br />"); 

        score = new_rating / new_count; 
    }
    else
    {
        try 
        {
            score = result.getInt("rating") / result.getInt("ratings");
	}
	catch (ArithmeticException e) 
        {
	    score = 0;
	}
    }

    // Display the title's relevant information 
%>
  <table width="80%">
    <tr>
      <td rowspan="2" width="20%"><img src="<%= result.getString("icon") %>" /></td>
      <td align="left"><font size="4"><b><%= result.getString("title") %></b></font>&nbsp;&nbsp;<% int i; for (i = 0; i < (int)score; i++) { out.println("<img src=\"/movies/images/star.gif\" />");} while (i < 5) { out.println("<img src=\"/movies/images/star_clear.gif\" />"); i++; } %></td>
    </tr>
    <tr>
      <td><%= result.getString("description") %></td>
    </tr>
    <tr>
      <td colspan="2"><b>Rated <%= result.getString("rated") %></b></td>
    </tr>
    <tr>
      <td>Release Date:</td>
      <td><i><%= result.getDate("date") %></i></td>
    </tr>
    <tr>
      <td>Media:</td>
      <td><%= result.getString("type").toUpperCase() %></td>
    </tr>
    <tr>
      <td>Genre:</td>
      <td><%= result.getString("genre") %></td>
    </tr>
    <tr>
      <td>Times Rented:</td>
      <td><%= result.getString("rentals") %></td>
    </tr>
    <tr>
      <td colspan="2"><br /></td>
    </tr>
    <tr>
      <td colspan="2"><%= getCartMarkup(result.getString("product_id"), result.getInt("in_stock")) %></td>
    </tr>
    <tr>
      <td colspan="2">Rate this title: <% for (i = 1; i <=5; i++) { out.println("<a href=\"/movies/common/listing.jsp?product_id=" + product_id + "&rating=" + i + "\"><img src=\"/movies/images/star_clear.gif\" border=\"0\"/></a>"); } %></td>
    </tr>
  </table>

</div>

<%@ include file="/movies/include/footer.tpl"    %>