<%
/**
 * A file that allows users and admins to search the
 * database for a particular title.
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.1.05
 */
%>

<%@ page import="java.sql.ResultSet"         %>
<%@ page import="java.sql.ResultSetMetaData" %>
<%@ page import="java.util.StringTokenizer"  %>

<jsp:useBean id="util"   class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"     class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user"   class="mcintyr.edu.montana.cs.esus.User"               scope="session" />

<%!
    // Page variables
    private int start_index  = 1;
    private int num_results  = 10;
    private int result_size  = 0;

    /**
     * A simple function for returning GET/POST variables that
     * ensures the result of a request is never null.
     * 
     * @param request - The request object.
     * @param name    - The GET/POST variable name.
     * @return - The resulting value, or the empty string if no value was found. 
     */ 
    
    private String getParameter(HttpServletRequest request, String name)
    {
        String value = request.getParameter(name);
        if (value == null)
            return "";
        else
            return value;     
    }
%>

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">
  <form action="/movies/common/search.jsp" method="post">
    Movie Title: 
    <input name="search" type="text" value="<% if (request.getParameter("search") != null) { out.println(request.getParameter("search")); } %>" \>
    <input type="submit" value="Search" />
    <hr />
  </form>

<%
    /**
     * If a search parameter is specified, perform the search.
     * Current search scheme: Check for every user-specified word
     * with the product titles. If a partial match is found, return that row.
     */ 
    
    if (request.getParameter("search") != null)
    {
        String query = "SELECT title, product_id FROM products WHERE ";
        StringTokenizer toke = new StringTokenizer(request.getParameter("search"));
        while (toke.hasMoreTokens())
        {
            if (toke.countTokens() > 1)
                query += "title LIKE('%" + toke.nextToken().replace("'", "\\'") + "%') AND ";
            else
                query += "title LIKE('%" + toke.nextToken().replace("'", "\\'") + "%');";
        } 

        ResultSet result = db.query(query);
        ResultSetMetaData rsmd = result.getMetaData();
  
        %>
        <table width="80%">
          <tr>
            <th align="left" colspan="2">Results:</th>
            <td><% if (user.getValue("user_type").equals("admin")) { out.println("product_id"); } else { out.println("<br />"); } %></td>
          </tr>
        <%
        int i = 1;
        while (result.next())
        {
            %>
          <tr>
            <td><%= i %></td>
            <td> - <a href="/movies/common/listing.jsp?product_id=<%= result.getString("product_id") %>"><%= result.getString("title") %></a></td>
            <td><% if (user.getValue("user_type").equals("admin")) { out.println(result.getString("product_id")); } else { out.println("<br />"); } %></td>
          </tr>
            <%   
            i++;
        }

        if (i == 1)
            out.println("<tr><td>Sorry, no corresponding results were found.</td></tr><br />");

        out.println("</table");
    }
%>
</div>

<%@ include file="/movies/include/footer.tpl"     %>