<%
/**
 * A file that allows users to view their orders and
 * personal information. 
 *
 * @Author  - Kyle McIntyre
 * @Version - 5.26.05
 */
%>

<%@ page import="java.sql.ResultSet"          %>
<%@ page import="java.sql.Date"               %>
<%@ page import="java.sql.ResultSetMetaData"  %>
<%@ page import="java.util.Enumeration"       %>
<%@ page import="java.util.StringTokenizer"   %>
<%@ page import="java.security.MessageDigest" %>
<%@ page import="sun.misc.BASE64Encoder"      %>

<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<%!
    // Constants
    private static final int FORM_SIZE = 9;
%>

<div class="page">
  <b>My Account</b>
  <br />
  <br />
  Welcome, <%= user.getValue("first") %> - 
  <a href="/movies/enduser/account.jsp?action=orders">View Your Rentals</a> | <a href="/movies/enduser/account.jsp?action=profile">Edit Your Profile</a>
  <br />
  <br />

<%
    // Extract the page action
    String action = request.getParameter("action");
    if (action == null)
        action = "orders";

    // Load appropriate content for page action
    if (action.equals("profile"))
    {
        // Handle possible profile modifications
        if (request.getParameter("submit") != null)
        {
            // Store form-related POST vars into the form array. 
            Enumeration columns = request.getParameterNames(); 
            while (columns.hasMoreElements())
            {
                String column = (String)columns.nextElement();
                if (!request.getParameter(column).equals("") && !column.equals("submit") && !column.equals("action"))
                    form.setValue(column, request.getParameter(column));
            }          

            // Ensure form was filled out completely and correctly. 
            if (form.size() == FORM_SIZE && util.checkForms(form))
            {
                // Attempt to make the changes
                String query = "UPDATE users SET ";
   
                for (int i = 0; i < form.size(); i++)
                {
                    query += form.getKey(i) + " = '" + form.getValue(i) + "'";
                    if (i < form.size() - 1)
                        query += ", ";
                }

                query += "WHERE user_id = '" + user.getValue("user_id") + "';";
                 
                if (db.update(query) > 0)
                {
                    util.updateUser(user);
                    out.println("Update successful. <br />");
                }
                else
                    out.println("Update failed. <br />");
            }
            else
            {
                if (form.size() > 0 && form.size() != FORM_SIZE)
                    out.println("Account modification failed. You failed to supply all of the necessary fields. <br />");
                else
                    out.println("Account modification failed. Some fields contained incorrect values.<br />");
            }  
        }
        else
        {
            out.println("Please keep your personal information up to date! If the information is outdated or incorrect we will be unable to deliver your movies. <br /><br />");
        }

        // Display the form
        %>
            <form action="account.jsp?action=profile" method="POST">
              [<a href="/movies/enduser/password.jsp">Change Your Password</a>]
              <br />
              <br />
              <table>
                <tr>
                  <td>Login:</td>
                  <td><input name="login" type="text" value="<%= user.getValue("login") %>"></td>
               </tr>
                <tr>
                  <td>Email</td>
                  <td><input name="email" type="text" value="<%= user.getValue("email") %>"></td>
                </tr>
                <tr>
                  <td>First Name:</td>
                  <td><input name="first" type="text" value="<%= user.getValue("first") %>"></td>
                </tr>
                <tr>
                  <td>Last Name:</td>
                 <td><input name="last" type="text" value="<%= user.getValue("last") %>"></td>
                </tr>
                <tr>
                  <td>Street Address:</td>
                  <td><input name="address" type="text" value="<%= user.getValue("address") %>"></td>
                </tr>
                <tr>
                  <td>City</td>
                  <td><input name="city" type="text" value="<%= user.getValue("city") %>"></td>
                </tr>
                <tr>
                  <td>State</td>
                  <td><input name="state" type="text" value="<%= user.getValue("state") %>"></td>
                </tr>
                <tr>
                  <td>Zip:</td>
                  <td><input name="zip" type="text" value="<%= user.getValue("zip") %>"></td>
                </tr>
                <tr>
                  <td>Phone:</td>
                  <td><input name="phone" type="text" value="<%= user.getValue("phone") %>">XXX-XXX-XXXX</td>
                </tr>
              </table>
              <br />
              <input type="submit" name="submit"  value="Submit Changes" />
            </form> 
        <%         
    }
    else // if action.equals("orders")
    {
        // Find orders that were made by the current user
        String query = "SELECT p.title, o.due_date FROM products p, orders o WHERE o.returned = '0' AND o.product_id = p.product_id AND o.user_id = '" + user.getValue("user_id") + "' ORDER BY o.due_date;";
        ResultSet result = db.query(query);

        out.println("<b>Your Rentals:</b><br /><br />");
        out.println("<table width=\"80%\">");
        out.println("<tr><th align=\"left\">Title</th><th align=\"left\">Due Date</th></tr>");
     
        boolean overdue = false;

        // Display all resulting orders. 
        while (result.next())
        {
%>
            <tr>
              <td>
                <%= result.getString("title") %>
              </td>
              <td>
<% 
            if (result.getDate("due_date").before(new Date(System.currentTimeMillis()))) 
            {
                out.println("<font color=\"red\">" + result.getString("due_date") + "</font>");
                overdue = true;
            }
            else
                out.println(result.getString("due_date"));
%>
              </td>
            </tr>              
<%
        }
        out.println("</table><br />");
        
        if (overdue)
            out.println("You have items that are overdue. Please return these items as quickly as possible to avoid further charges and account cancellation. <br />"); 

        // Display the user's shopping cart
        out.println("<br /><b>Items in Your Cart</b><br /><br />");

        if (user.getValue("cart").equals(""))
            out.println("Your cart is currently empty.<br />");
        else
        {
            StringTokenizer toke = new StringTokenizer(user.getValue("cart"), ",");
            query = "SELECT title FROM products WHERE ";
            while (toke.hasMoreTokens())
            {
                query += "product_id = '" + toke.nextToken() + "' OR ";
            }
            // Remove erroneous OR
            query = query.substring(0, query.length() - 4);
            query += ";";

            // Display the resulting products
            result = db.query(query);
            while (result.next())
                out.println(result.getString("title") + "<br />"); 
        }
    }
%>
</div>

<%@ include file="/movies/include/footer.tpl"     %>