<%
/**
 * A file that allows a new (guest) user to register. 
 *
 * @Author  - Kyle McIntyre
 * @Version - 6.6.05
 */
%>

<%@ page import="java.util.Enumeration"       %>
<%@ page import="java.security.MessageDigest" %>
<%@ page import="sun.misc.BASE64Encoder"      %>

<jsp:useBean id="util" class="mcintyr.edu.montana.cs.esus.Utilities"          scope="session" />
<jsp:useBean id="db"   class="mcintyr.edu.montana.cs.esus.DatabaseConnection" scope="session" />
<jsp:useBean id="user" class="mcintyr.edu.montana.cs.esus.User"               scope="session" />
<jsp:useBean id="form" class="mcintyr.edu.montana.cs.esus.AssociativeArray"   scope="page"    />

<%!
    // Constants
    private static final int FORM_SIZE = 10;
%>

<%@ include file="/movies/include/header.tpl"     %>
<%@ include file="/movies/include/navigation.jsp" %>

<div class="page">

<%
    // Load in all POST variables
    Enumeration columns = request.getParameterNames(); 
    while (columns.hasMoreElements())
    {
        String column = (String)columns.nextElement();
        if (!request.getParameter(column).equals("") && !column.equals("submit"))
	{
	    // Escape single quotes to preserve SQL integrity
            form.setValue(column, request.getParameter(column).replaceAll("'", "\\'"));
	}
    } 
 
    // Ensure form is filled out correctly and login is unique. 
    if (form.size() == FORM_SIZE && util.checkForms(form) && user.getValue("user_type").equals("guest") 
        && util.isLoginUnique(form.getValue("login")))
    {
        // Form filled out correctly. Insert new user into database.

        // Encrypt the password
        MessageDigest md = MessageDigest.getInstance("MD5");
        md.update(form.getValue("password").getBytes("UTF8"));
        form.setValue("password", (new BASE64Encoder().encode(md.digest())).replace("'", "\\'")); 

        String query = "INSERT INTO users (";

        for (int i = 0; i < form.size(); i++)
            query += form.getKey(i) + ", ";
 
        query += "user_type) VALUES(";

        for (int i = 0; i < form.size(); i++)
            query += "'" + form.getValue(i) + "', "; 

        query += "'enduser');";
 
        if (db.update(query) > 0)
            out.println("Thank you for your registration! You've been successfully added to our database. Please follow the \"Login\" link to login and begin browsing our online movie collection. <br /> <br />");
        else
            out.println("Registration failed. <br />");
    }
    else
    {
        if (!user.getValue("user_type").equals("guest"))
        {
            out.println("You are already registered and logged in. Please follow the logout link if you are not " + user.getValue("first") + "<br />");
        }
        else if (!form.getValue("login").equals("") && !util.isLoginUnique(form.getValue("login")))
        {
            out.println("Please choose another login. <br />");
        }
        else if (form.size() > 0 && form.size() < FORM_SIZE)
        {
            out.println("Please fill out every field. <br />");
        }
        else if (!util.checkForms(form))
        {
            out.println("Some fields contained incorrect values.<br />");     
        }
        else
        {
           out.println("Already registered? <a href=\"/movies/public/login.jsp\">Login</a><br /><br />");
           out.println("In order to rent movies or games from McMovies, you need to have an active account. Accounts are free and signup is simple! Completely fill out the form below and click Submit. Your application will then be processed and you will be added to our online database. You will then be able to check out movies and view your account status online.<br />");
        }

        // Display the registration form. 
        %>
           <br />
           <br />
           <form action="register.jsp" method="POST">
             <table>
               <tr>
                 <td>Username:</td>
                 <td><input name="login" type="text" value="<%= form.getValue("login") %>" ></td>
               </tr>
               <tr>
                 <td>Password:</td>
                 <td><input name="password" type="password"></td>
               </tr>
               <tr>
                 <td>Email:</td>
                 <td><input name="email" type="text" value="<%= form.getValue("email") %>"></td>
               </tr>
               <tr>
                 <td><br /><br /></td>
                 <td><br /><br /></td>
               </tr>
               <tr>
                 <td>First Name:</td>
                 <td><input name="first" type="text" value="<%= form.getValue("first") %>"></td>
               </tr>
               <tr>
                 <td>Last Name:</td>
                 <td><input name="last" type="text" value="<%= form.getValue("last") %>"></td>
               </tr>
               <tr>
                 <td>Street Address:</td>
                 <td><input name="address" type="text" value="<%= form.getValue("address") %>"></td>
               </tr>
               <tr>
                 <td>City</td>
                 <td><input name="city" type="text" value="<%= form.getValue("city") %>"></td>
               </tr>
               <tr>
                 <td>State</td>
                 <td><input name="state" type="text" value="<%= form.getValue("state") %>"></td>
               </tr>
               <tr>
                 <td>Zip:</td>
                 <td><input name="zip" type="text" value="<%= form.getValue("zip") %>"></td>
               </tr>
               <tr>
                 <td>Phone:</td>
                 <td><input name="phone" type="text" value="<%= form.getValue("phone") %>"> XXX-XXX-XXXX</td>
               </tr>
             </table>
             <input type="submit" name="submit" value="Submit" />
           </form>
         <%
    }
%>

</div>

<%@ include file="/movies/include/footer.tpl"    %>