/* 
SQLyog v4.04
Host - localhost : Database - project
**************************************************************
Server version 4.1.11-nt
*/

create database if not exists `project`;

use `project`;

/*
Table structure for fees
*/

drop table if exists `fees`;
CREATE TABLE `fees` (
  `fee_name` text NOT NULL,
  `fee_value` float NOT NULL default '0',
  `fee_id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`fee_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Table data for project.fees
*/

INSERT INTO `fees` VALUES 
('Rental Fee',3,1),
('Late Fee',2.25,2),
('Latest Release Fee',4.25,3),
('Damage Fee',5,4);

/*
Table structure for genres
*/

drop table if exists `genres`;
CREATE TABLE `genres` (
  `genre_id` int(11) NOT NULL auto_increment,
  `genre_name` text,
  PRIMARY KEY  (`genre_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Table data for project.genres
*/

INSERT INTO `genres` VALUES 
(1,'Adventure'),
(2,'Action'),
(3,'Animation'),
(4,'Anime'),
(6,'Thriller'),
(7,'Drama'),
(8,'Comedy'),
(9,'Romance'),
(10,'Family');

/*
Table structure for media_types
*/

drop table if exists `media_types`;
CREATE TABLE `media_types` (
  `type_id` int(11) NOT NULL auto_increment,
  `type_name` text NOT NULL,
  PRIMARY KEY  (`type_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Table data for project.media_types
*/

INSERT INTO `media_types` VALUES 
(1,'VHS'),
(2,'DVD'),
(3,'Game'),
(7,'Cassette');

/*
Table structure for orders
*/

drop table if exists `orders`;
CREATE TABLE `orders` (
  `order_id` int(11) NOT NULL auto_increment,
  `product_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `due_date` date NOT NULL default '0000-00-00',
  `returned` tinyint(1) NOT NULL default '0',
  `fee` float NOT NULL default '3',
  `date` date NOT NULL default '2005-06-04',
  PRIMARY KEY  (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


/*
Table structure for products
*/

drop table if exists `products`;
CREATE TABLE `products` (
  `product_id` int(11) NOT NULL auto_increment,
  `title` text NOT NULL,
  `date` date NOT NULL default '0000-00-00',
  `type` text NOT NULL,
  `genre` text,
  `quantity` int(11) NOT NULL default '0',
  `in_stock` int(11) NOT NULL default '0',
  `rentals` int(11) NOT NULL default '0',
  `rating` int(11) NOT NULL default '0',
  `ratings` int(11) NOT NULL default '0',
  `description` longtext,
  `fee_type` text NOT NULL,
  `icon` text NOT NULL,
  `rated` text NOT NULL,
  PRIMARY KEY  (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Table structure for ratings
*/

drop table if exists `ratings`;
CREATE TABLE `ratings` (
  `rating_id` int(11) NOT NULL auto_increment,
  `rating_name` text NOT NULL,
  PRIMARY KEY  (`rating_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Table data for project.ratings
*/

INSERT INTO `ratings` VALUES 
(1,'G'),
(2,'PG'),
(3,'PG-13'),
(4,'R'),
(5,'NC17'),
(6,'Mature');

/*
Table structure for users
*/

drop table if exists `users`;
CREATE TABLE `users` (
  `login` text NOT NULL,
  `password` text NOT NULL,
  `first` text NOT NULL,
  `last` text NOT NULL,
  `address` text NOT NULL,
  `city` text NOT NULL,
  `state` text NOT NULL,
  `zip` text NOT NULL,
  `phone` text NOT NULL,
  `email` text NOT NULL,
  `user_id` int(11) NOT NULL auto_increment,
  `user_type` text NOT NULL,
  PRIMARY KEY  (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*
Create the administrator account. 
*/

INSERT INTO `project`.`users` ( `login`, `password`, `first`, `last`, `address`, `city`, `state`, `zip`, `phone`, `email`, `user_id`, `user_type` ) VALUES (  'admin',  'ISMvKXpXpadDiUoOSoAfww==',  'Administrator',  '',  '',  '',  '',  '',  '',  '',  NULL,  'admin' );